<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: headers/roundcard.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7f57b1e41c5acd0e859ae5f3a2b075a9.html">headers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">roundcard.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef ROUNDCARDS_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define ROUNDCARDS_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;QGraphicsObject&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;qpainter.h&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include&lt;miniround.h&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;serializable.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;miniroundcollection.h&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">enum class</span> RoundCardType {</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    THREE_TO_FOUR_PLAYERS,</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    FIVE_TO_SIX_PLAYERS,</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    TRAIN_STATION</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;}; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">enum class</span> EventType {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    ANGRY_MARSHAL,</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    SWIVEL_ARM,</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    BRACKING,</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    TAKE_IT_ALL,</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    PASSENGERS_REBELLION,</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    PICKPOCKETING,</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    MARSHALS_REVENGE,</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    HOSTAGE_TACKING_OF_THE_CONDUCTOR,</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    NONE</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;};</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;std::string toStringRoundCardType(<span class="keyword">const</span> RoundCardType &amp;card);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;std::string toStringEventType(<span class="keyword">const</span> EventType &amp;event);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;std::string toStringMiniRoundType(<span class="keyword">const</span> MiniRoundType &amp;miniRound);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classRoundCard.html">   39</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRoundCard.html">RoundCard</a>:<span class="keyword">public</span> QGraphicsObject, <span class="keyword">public</span> <a class="code" href="classSerializable.html">Serializable</a></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;{</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    Q_OBJECT</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="comment">// Constructors</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classRoundCard.html">RoundCard</a>();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <a class="code" href="classRoundCard.html">RoundCard</a>(RoundCardType type, EventType event, <span class="keyword">const</span> std::vector&lt;MiniRoundType&gt; &amp;miniRound);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <a class="code" href="classRoundCard.html">RoundCard</a>(RoundCardType type, EventType event, <span class="keyword">const</span> <a class="code" href="classMiniRoundCollection.html">MiniRoundCollection</a> &amp;miniRound);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="comment">// Destructor</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    ~<a class="code" href="classRoundCard.html">RoundCard</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="comment">// Get methods</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    RoundCardType typeOfRoundCard() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="classMiniRoundCollection.html">MiniRoundCollection</a>&amp; getMiniRounds();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    EventType event() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="comment">// Set methods</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> setType(RoundCardType &amp;newType);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> setEvent(EventType &amp;newEvent);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment">// Other methods</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordtype">void</span> push_back(<a class="code" href="classMiniRound.html">MiniRound</a>*);</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="classMiniRound.html">MiniRound</a>* back();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <a class="code" href="classMiniRound.html">MiniRound</a>* front();</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">int</span> size() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="classMiniRound.html">MiniRound</a>* operator[](<span class="keywordtype">int</span>);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    std::string toString() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="comment">// GUI</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordtype">int</span> height()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordtype">int</span> width()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    QRectF boundingRect() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">void</span> paint(QPainter *painter, <span class="keyword">const</span> QStyleOptionGraphicsItem *option, QWidget *widget);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="comment">// Serializable interface</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    QVariant toVariant() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> fromVariant(<span class="keyword">const</span> QVariant &amp;variant);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    RoundCardType m_type;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    EventType m_event;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="classMiniRoundCollection.html">MiniRoundCollection</a> m_miniRounds;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;};</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="preprocessor">#endif </span><span class="comment">//ROUNDCARDS_H</span></div>
<div class="ttc" id="aclassMiniRoundCollection_html"><div class="ttname"><a href="classMiniRoundCollection.html">MiniRoundCollection</a></div><div class="ttdef"><b>Definition:</b> miniroundcollection.h:10</div></div>
<div class="ttc" id="aclassMiniRound_html"><div class="ttname"><a href="classMiniRound.html">MiniRound</a></div><div class="ttdef"><b>Definition:</b> miniround.h:14</div></div>
<div class="ttc" id="aclassRoundCard_html"><div class="ttname"><a href="classRoundCard.html">RoundCard</a></div><div class="ttdef"><b>Definition:</b> roundcard.h:40</div></div>
<div class="ttc" id="aclassSerializable_html"><div class="ttname"><a href="classSerializable.html">Serializable</a></div><div class="ttdef"><b>Definition:</b> serializable.h:9</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
